\\ Copyright 2016 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
iferr(read("recurrence-guess.gp"),e,read("../recurrence-guess.gp"));

\\-----------------------------------------------------------------------------
vm(v,i) = v[(i% #v)+1];

my_vector = I*vector(50,k,k--; vm([1,-0,1,-1, 0,1,-1,1],k)*2^floor(k/2));
my_vector = I*vector(50,k,k--; vm([1,2,3,4,5,6,7,8],k)*1^floor(k/2));
my_vector = I*vector(50,k,k--; vm([0,-1,1,-1, 0,1,-1,1],k)*2^floor(k/2));
{
  print(my_vector);
 recurrence_guess(my_vector);
}

factor(1 + 2*x + 2*x^2)
factor((1 + 2*x + 2*x^2)*I)

\\ conjugate roots x^2 - 2*a*x + (a^2 + b^2)
\\ x^2 - x + 1  is a=1/2, b^2+1/4=1, b=sqrt(3)/2
\\ norm a^2+b^2
r=a+b*I;
(x-r)*(x-conj(r))
norm(r)

r=1/(-1/2 + 1/2*I);
(x-r)*(x-conj(r))
print("norm ",norm(r))
r^2
r^3
r^4
quit

sqrt3i = quadgen(-4*3);
w3 = -1/2 + 1/2*sqrt3i
w3^3
(x-w3)*(x-w3^2)*(x-w3^3)

w6 = 1/2 + 1/2*sqrt3i
w6^3
w6^6
(x-w6)*(x-w6^5)

recurrence_guess_INTERNAL_gf_terms(1/(x^2 - x + 1),24)

vector(16,k,k--; vm([1,-0,1,-1, 0,1,-1,1],k)*2^floor(k/2))
(x^4-2^32)/(1 + 2*x + 2*x^2)
